<?php 

    //namespace jeuquantik\src;
/**
 * Classe PieceQuantik
 * @authors Thiziri KECHIDI & Mourad HADJ ali
 * @date 2021-2022
 * @version 1.3 compatible php7.4
 */


class PieceQuantik {
    /**
     * $coordonnée pièce : entier entre 0 et 4 indiquant la couleur et la forme de la piece
     * @access public
     * @var const
     */

    public const WHITE = 0;
        public const BLACK = 1;
        public const VOID = 0;
        public const CUBE = 1;
        public const CONE = 2;
        public const CYLINDRE = 3;
        public const SPHERE = 4;

    /**
     * $FORME_COULEUR :
     * @access private
     * @var const
     */

    private const FORME_COULEUR =
        [
            self::VOID     => "[VOID]",
            self::CUBE     => [self::WHITE => "[Cu:W]", self::BLACK => "[Cu:B]"],
            self::CONE     => [self::WHITE => "[Co:W]", self::BLACK => "[Co:B]"],
            self::CYLINDRE => [self::WHITE => "[Cy:W]", self::BLACK => "[Cy:B]"],
            self::SPHERE   => [self::WHITE => "[Sp:W]", self::BLACK => "[Sp:B]"],
        ];


        protected int $forme;//array("cube","cone","cylindre","sphere");
        protected int $couleur;//array("black","white");


    /**
     * @access private
     * @param int $forme l'entier associé à la forme
     * @param int $couleur l'entier associé à la couleur
     */

    private function __construct(int $forme, int $couleur)
        {
            $this->forme   = $forme;
            $this->couleur = $couleur;
        }
    /**
     * @access public
     * @return int $this->forme
     */

        public function getForme(): int {
            return $this->forme;
        }
    /**
     * @access public
     * @return int $this->couleur
     */


    public function getCouleur(): int {
            return $this->couleur;
        }
    /**
     * @access public
     * @return string une chaîne de caractères résumant $this
     */


        public function __toString(): string
        {
            $image = '<img';
            /*$forme = $this->forme;
            if ( $forme == self::VOID ) return self::FORME_COULEUR[$forme];
            return self::FORME_COULEUR[$forme][$this->couleur];*/
            switch($this->getForme()) {
                case self::CONE : {
                    if($this->getCouleur() == self::WHITE) {
                        $image.=' src="../src/images/coneBlanc.png" class="img" alt="cone noir" width="50" height="50" />';
                    } else {
                        $image.=' src="../src/images/coneNoir.png" class="img" alt="cone noir" width="50" height="50" />';
                    }
                    break;
                }
                case self::CUBE : {
                    if($this->getCouleur() == self::WHITE) {
                        $image.=' src="../src/images/cubeBlanc.png" class="img" alt="cube noir" width="50" height="50" />';
                    } else {
                        $image.=' src="../src/images/cubeNoir.png" class="img" alt="cube noir" width="50" height="50" />';
                    }
                    break;
                }
                case self::CYLINDRE : {
                    if($this->getCouleur() == self::WHITE) {
                        $image.=' src="../src/images/cylindreBlanc.png" class="img" alt="cylindre noir" width="50" height="50" />';
                    } else {
                        $image.=' src="../src/images/cylindre.png" class="img" alt="cylindre noir" width="50" height="50" />';
                    }
                    break;
                }
                case self::SPHERE : {
                    if($this->getCouleur() == self::WHITE) {
                        $image.=' src="../src/images/sphereBlanc.png" class="img" alt="sphere noir" width="50" height="50" />';
                    } else {
                        $image.=' src="../src/images/sphereNoir.png" class="img" alt="sphere noir" width="50" height="50" />';
                    }
                    break;
                }
            }
            return $image;

        }


        /**
         * @access public
         */



    public static function initVoid(): self {
            return new PieceQuantik(self::VOID, self::WHITE);
        }
        
        public static function initWhiteCube(): self {
            return new PieceQuantik(self::CUBE, self::WHITE);
        }

        public static function initBlackCube(): self {
            return new PieceQuantik(self::CUBE, self::BLACK);
        }

        public static function initWhiteCone(): self {
            return new PieceQuantik(self::CONE, self::WHITE);
        }

        public static function initBlackCone(): self {
            return new PieceQuantik(self::CONE, self::BLACK);
        }
        
        public static function initWhiteCylindre(): self {
            return new PieceQuantik(self::CYLINDRE, self::WHITE);
        }
        
        public static function initBlackCylindre(): self {
            return new PieceQuantik(self::CYLINDRE, self::BLACK);
        }
        
        public static function initWhiteSphere(): self {
            return new PieceQuantik(self::SPHERE, self::WHITE);
        }

        public static function initBlackSphere(): self {
            return new PieceQuantik(self::SPHERE, self::BLACK);
        }
    }
?>
